<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use FM\Service\Fm00005000VistoriasService;
use FM\Traits\TResponse;

class Fm00005000VistoriasController extends FMCrud
{

    use TResponse;

    protected $dataSourceName = 'fcm_checklistagend';
    protected $Fm00005000VistoriasService;

    public function __construct($crudService, $environment, Fm00005000VistoriasService $Fm00005000VistoriasService)
    {
        parent::__construct($crudService, $environment);
        $this->Fm00005000VistoriasService = $Fm00005000VistoriasService;
        $this->Environment = $environment;
    }

    // Busca nome e local da vistoria
    public function getVistorias()
    {
        try {
            $data = $this->Fm00005000VistoriasService->getVistorias();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getCriteriosGrid(Request $request)
    {
        try {
            $data = $this->Fm00005000VistoriasService->getCriteriosGrid($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    // Salva as informações de Vistoria
    public function updateInspection(Request $request)
    {
        try {
            $data = $this->Fm00005000VistoriasService->updateInspection($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
