/* eslint-disable */
import { Utilities } from '@/util/Utilities';
import {
    CheckboxMultiple, Date as ZdDate, DialogService, Form, LoadingService, Modal, ModalService,
    Select, SelectMultiple, TextInput, Text, Time, DateRange,
} from '@zeedhi/common';
import { Http, IEventParam, Metadata } from '@zeedhi/core';
import { TekGrid } from '@zeedhi/teknisa-components-common';
import { ZdTime } from '@zeedhi/vuetify';

export class Fm00030000TarefasRecorrentesController {
    private cadastroTarefa!: Modal;

    private modalCriterio!: Modal;

    private modalPlayTarefa!: Modal;

    private modalPauseTarefa!: Modal;

    private modalEdicaoTarefa!: Modal;

    private cancelamentoTarefas!: Modal;

    private modalConflitoDatas!: Modal;

    private modalConflitos!: Modal;

    public controlePlayPause!: boolean;

    public conflitoRel!: Boolean;

    public botaoConflito!: boolean;

    private clicks = 0;

    public linhaClicada: any;

    public dadosGrid: any;

    public bancoConflito: any = [];

    public visibilidadeGridItens: boolean = false;

    public visibilidadeForm: boolean = true;

    public conflitoDatas: any = [];

    public conflitoRelatorio: any = [];

    public copy: any;

    public title: String = "";

    public parametrizacao = "";

    public gridEditavel = false;


    /* ---------- Controle dos modais ---------- */
    public async addNewRow() {
        this.cadastroTarefa = await ModalService.createFromJsonPost('', { jsonPath: 'fm_00030_000_tarefas_recorrentes/modal/fm_00030_001_modal_cadastro_tarefas_recorrentes' });
        this.cadastroTarefa.show();
        this.validaParametrizacao();
    }

    public async fecharModalTarefas() {
        this.cadastroTarefa.hide();
        this.cadastroTarefa?.destroy();
    }

    public async exibirModalCriterios() {
        this.modalCriterio = await ModalService.createFromJsonPost('', { jsonPath: 'fm_00030_000_tarefas_recorrentes/modal/fm_00030_002_modal_cadastro_criterios' });
        this.modalCriterio.show();
    }

    public async fecharModalCriterio() {
        this.modalCriterio.hide();
        this.modalCriterio?.destroy();
    }

    public async exibirModalCancelamento() {
        this.cancelamentoTarefas = await ModalService.createFromJsonPost('', { jsonPath: 'fm_00030_000_tarefas_recorrentes/modal/fm_00030_006_modal_cancelar_tarefas' });
        this.cancelamentoTarefas.show();
    }

    public async fecharModalCancelamento() {
        this.cancelamentoTarefas.hide();
        this.cancelamentoTarefas?.destroy();
    }

    public async modalPlayPause(row: any) {
        if (row.NMIDSITUACAO === 'Pausada') {
            this.modalPlayTarefa = await ModalService.createFromJsonPost('', { jsonPath: 'fm_00030_000_tarefas_recorrentes/modal/fm_00030_003_modal_play_tarefas' });
            this.modalPlayTarefa.show();
        } else if (row.NMIDSITUACAO === 'Em Andamento') {
            this.modalPauseTarefa = await ModalService.createFromJsonPost('', { jsonPath: 'fm_00030_000_tarefas_recorrentes/modal/fm_00030_004_modal_pause_tarefas' });
            this.modalPauseTarefa.show();
        }
    }

    public async fecharModalPause() {
        this.modalPauseTarefa.hide();
        this.modalPauseTarefa?.destroy();
    }

    public async fecharModalPlay() {
        this.modalPlayTarefa.hide();
        this.modalPlayTarefa?.destroy();
    }

    public async exibirModalEdicao() {
        this.modalEdicaoTarefa = await ModalService.createFromJsonPost('', { jsonPath: 'fm_00030_000_tarefas_recorrentes/modal/fm_00030_005_modal_editar_tarefas' });
        this.modalEdicaoTarefa.show();
        setTimeout(() => {
            this.setInfo(this.linhaClicada);
        }, 500);
    }

    public async exibirModalConflitoDatas() {
        if (this.modalConflitoDatas) {
            await this.fecharModalConflitoDatas();
        }
        this.modalConflitoDatas = await ModalService.createFromJsonPost('', { jsonPath: 'fm_00030_000_tarefas_recorrentes/modal/fm_00030_007_modal_conflito_datas' });
        this.modalConflitoDatas.show();
    }

    public async fecharModalConflitoDatas() {
        this.modalConflitoDatas.hide();
        this.modalConflitoDatas?.destroy();
        this.visibilidadeGridItens = false;
        this.visibilidadeForm = true;
    }

    public setInfo(row: any) {
        Metadata.getInstance<Text>('nomeTarefa').text = row.NMTAREFA;
        Metadata.getInstance<Text>('nomeLocal').text = row.NMLOCALCLIENTE;
        Metadata.getInstance<Text>('situacaoTarefa').text = row.NMIDSITUACAO;
        Metadata.getInstance<Time>('selectHoraInicio1').value = row.HORARIO;
        Metadata.getInstance<TextInput>('selectTempoMedio1').value = row.DURACAO;
        Metadata.getInstance<SelectMultiple>('selectDiaSemana').setValue(row.DIASSEMANA.split(','));
        Metadata.getInstance<Select>('selectFuncionario').setValue(row.CDOPERTAREFA);
        Metadata.getInstance<Select>('selectEncarregado').setValue(row.CDOPERVISTORIA);
    }

    public async fecharModalEdicao() {
        this.modalEdicaoTarefa.hide();
        this.modalEdicaoTarefa?.destroy();
    }

    public async exibirRelatorio() {
        this.modalConflitos = await ModalService.createFromJsonPost('', { jsonPath: 'fm_00030_000_tarefas_recorrentes/modal/fm_00030_008_modal_relatorio_conflito' });
        this.modalConflitos.show();
    }

    public async fecharRelatorio() {
        this.botaoConflito = false;
        this.modalConflitos.hide();
        this.modalConflitos?.destroy();
        this.gridEditavel = false;
        const grid = Metadata.getInstance<TekGrid>('tek-grid-tarefas-recorrentes');
        grid.datasource.get();
    }


    public clickButtonToExpand({ component }: any) {
        const form = Metadata.getInstance<Form>(`formTarefas_${component.name}`);
        form.isVisible = !form.isVisible;
        component.iconName = (component.iconName === 'mdi-chevron-down') ? 'mdi-chevron-right' : 'mdi-chevron-down';
    }

    // ========== Controles dos Selects ===================
    public changeTipoDeLocal() {
        const cliente = Metadata.getInstance<Select>('CDCLIENTE');
        const tipoLocal = Metadata.getInstance<Select>('NRTIPOLOCALCLI');
        if (cliente.value) {
            tipoLocal.disabled = false;
        } else {
            tipoLocal.disabled = true;
        }
    }

    public changeLocal() {
        const tipoLocal = Metadata.getInstance<Select>('NRTIPOLOCALCLI');
        const local = Metadata.getInstance<Select>('NRLOCALCLIENTE');
        const checklist = Metadata.getInstance<Select>('NRCHECKLIST');
        if (tipoLocal.value > 0) {
            local.disabled = false;
            checklist.disabled = false;
            local.datasource.setFilter({
                NRTIPOLOCALCLI: tipoLocal.value,
                UNICA: "S",
            });
            checklist.datasource.setFilter({
                NRTIPOLOCALCLI: tipoLocal.value,
                UNICA: "S",
            });
        } else {
            local.setValue([]);
            local.disabled = true;
            checklist.setValue(null);
            checklist.disabled = true;
        }
    }

    public changeItensChecklist() {
        const checklist = Metadata.getInstance<Select>('NRCHECKLIST');
        const itenschecklist = Metadata.getInstance<SelectMultiple>('NRATIVIDADECHK');
        if (checklist.value) {
            itenschecklist.disabled = false;
            itenschecklist.datasource.setFilter({
                NRCHECKLIST: checklist.value,
            });
        } else {
            itenschecklist.setValue([]);
            itenschecklist.disabled = true;
        } 
    }

    public changeEscopo() {
        const itenschecklist = Metadata.getInstance<SelectMultiple>('NRTIPOLOCALCLI');
        const escopo = Metadata.getInstance<Select>('NRESCOPOSTAREFA');
        if (itenschecklist.value > 0) {
            escopo.disabled = false;
        } else {
            escopo.setValue([]);
            escopo.disabled = true;
        }
    }

    public changeTarefa() {
        const escopo = Metadata.getInstance<SelectMultiple>('NRESCOPOSTAREFA');
        const tarefa = Metadata.getInstance<SelectMultiple>('NRTAREFACHK');
        const itenschecklist = Metadata.getInstance<Select>('NRATIVIDADECHK');
        if (escopo.value > 0) {
            tarefa.disabled = false;
            tarefa.datasource.setFilter({
                NRATIVIDADECHK: itenschecklist.value,
            });
        } else {
            tarefa.setValue([]);
            tarefa.disabled = true;
        }
    }

    public changeContratos({ component }: any) {
        const selectContratos = Metadata.getInstance<Select>('NRSEQCONTRATO');

        if (component.value > 0) {
            selectContratos.disabled = false;
            const { selectValue } = component;
            selectContratos.datasource.setFilter({
                NRESTRUTURAM: selectValue.NRESTRUTURAM,
            });
        } else if (component.value.length < 1) {
            selectContratos.disabled = true;
        }
    }

    public setCriterios() {
        const tarefa = Metadata.getInstance<SelectMultiple>('NRTAREFACHK');
        const itenschecklist = Metadata.getInstance<Select>('NRATIVIDADECHK');
        const checklist = Metadata.getInstance<Select>('NRCHECKLIST');
        const checkbox = Metadata.getInstance<CheckboxMultiple>('NRCRITERIOTAREFACHK');
        if (tarefa.value.length > 0) {
            checkbox.datasource?.setFilter({
                NRTAREFACHK: tarefa.value,
                NRATIVIDADECHK: itenschecklist.value,
                NRCHECKLIST: checklist.value,
            });
            checkbox.datasource?.get();
            checkbox.isVisible = true;
        } else {
            tarefa.setValue([]);
            checkbox.isVisible = false;
        }
    }

    public novoCriterio() {
        const chk = Metadata.getInstance<CheckboxMultiple>('NRCRITERIOTAREFACHK');
        const valor = Metadata.getInstance<TextInput>('inputNovoCriterio').value;
        chk!.datasource!.data!.push({
            NRCRITERIOTAREFACHK: valor,
            DSCRITERIOTAREFA: valor,
        });
        chk!.value.push(valor);
        this.fecharModalCriterio();
    }

    public validaVistoria() {
        const vistoria = Metadata.getInstance<Select>('selectCriarVistoria');
        const observacao = Metadata.getInstance<Select>('selectObservacoesObrigatorias');
        if (vistoria.value === 1) {
            observacao!.datasource!.data!.push({
                value: '3',
                text: 'Somente na vistoria',
            });
            observacao!.datasource!.data!.push({
                value: '4',
                text: 'Na tarefa e na vistoria',
            });
        } else {
            observacao.datasource?.get();
        }
    }

    public validaDiaPeriodo(data: any, data2: any, dias: any) {
        for (let dataAux = data; data <= data2; dataAux.setDate(dataAux.getDate() + 1)) {
            if (dias.includes(String(dataAux.getDay()))) {
                return true;
            }
        }
        return false;
    }

    /* ================ Funções responsáveis para fazer a inserção das tarefas ===================================== */

    public validaInsercao() {
        if (this.linhaClicada != undefined && this.linhaClicada['IDERRO'] == 'S') {
            return true
        } else {
            const formTarefas = Metadata.getInstance<Form>('formCadastroTarefas').validate();
            const formCriterios = Metadata.getInstance<Form>('formTarefas_dropBoxCriterioAvaliacao').validate();
            const formAgendamento = Metadata.getInstance<Form>('formTarefas_dropBoxDadosAgendamento').validate();
            return (formTarefas && formCriterios && formAgendamento);
        }
    }

    public executorHora() {
        let dados = [];
        dados.push({
            HORAINICIO: Metadata.getInstance<Time>('selectHoraInicio').value,
            DURACAO: Metadata.getInstance<TextInput>('selectdDuracao').value,
            FUNCIONARIO: Metadata.getInstance<Select>('selectFuncionario').value,
            ENCARREGADO: Metadata.getInstance<Select>('selectEncarregado').value,
            NRSEQCONTRATO: Metadata.getInstance<Select>('NRSEQCONTRATO').value,
        });

        return dados;
    }

    public inserirTarefa() {
        if (this.conflitoRelatorio.length > 0) {
            const grid = Metadata.getInstance<TekGrid>('tek-grid-relatorios');
            LoadingService.show();
            Http.post('/insertTarefasRecorrentes', {
                EXECUTORHORA: this.conflitoRelatorio,
                RELATORIO: 'S',
                NRTAREFARECORRENTE: this.linhaClicada.NRTAREFARECORRENTE,
                NRSEQCONTRATO: this.linhaClicada.NRSEQCONTRATO,
                EDITROWS: this.conflitoRelatorio,
            }).then(() => {
                Utilities.showSuccessMessage();
            }).catch((error: any) => {
                Utilities.showErrorMessage(error);
            }).finally(() => {
                grid.datasource.get();
                LoadingService.hide();
            });
        } else {
            const grid = Metadata.getInstance<TekGrid>('tek-grid-tarefas-recorrentes');
            const checkBoxMultiple = Metadata.getInstance<CheckboxMultiple>('NRCRITERIOTAREFACHK');
            LoadingService.show();
            Http.post('/insertTarefasRecorrentes', {
                NOMETAREFA: Metadata.getInstance<TextInput>('nomeTarefa').value,
                CDCLIENTE: Metadata.getInstance<Select>('CDCLIENTE').value,
                NRTIPOLOCALCLI: Metadata.getInstance<SelectMultiple>('NRTIPOLOCALCLI').value,
                NRLOCALCLIENTE: Metadata.getInstance<SelectMultiple>('NRLOCALCLIENTE').value,
                NRCHECKLIST: Metadata.getInstance<Select>('NRCHECKLIST').value,
                NRATIVIDADECHK: Metadata.getInstance<SelectMultiple>('NRATIVIDADECHK').value,
                NRESCOPOSTAREFA: Metadata.getInstance<SelectMultiple>('NRESCOPOSTAREFA').value,
                NRTAREFACHK: Metadata.getInstance<SelectMultiple>('NRTAREFACHK').value,
                NRCRITERIOTAREFACHK: checkBoxMultiple.datasource?.data.filter((box: any) => checkBoxMultiple.value.indexOf(box.NRCRITERIOTAREFACHK) >= 0),
                DATERANGE: [Metadata.getInstance<ZdDate>('selectDataDe').value],
                DIASEMANA: Metadata.getInstance<SelectMultiple>('selectDiaSemana').value,
                VISTORIA: Metadata.getInstance<Select>('selectCriarVistoria').value,
                OBSERVACOES: Metadata.getInstance<Select>('selectObservacoesObrigatorias').value,
                EXECUTORHORA: this.bancoConflito,
                SWITCHFUNCIONARIO: 'null',

            }).then(() => {
                Utilities.showSuccessMessage();
                this.fecharModalTarefas();
                grid.datasource.get();
            }).catch((error: any) => {
                Utilities.showErrorMessage(error);
            }).finally(() => {
                LoadingService.hide();
            });
        }
    }

    /* ============================================================================================ */

    public pausarTarefaRecorrente() {
        const grid = Metadata.getInstance<TekGrid>('tek-grid-tarefas-recorrentes');
        LoadingService.show('Pausando...');

        Http.post('/tarefasRecorrentes', {
            TIPO: 'PAUSAR',
            NRTAREFARECORRENTE: this.linhaClicada.NRTAREFARECORRENTE,
            DATAINICIAL: Metadata.getInstance<ZdDate>('dataInicio').value,
            DATAFINAL: Metadata.getInstance<ZdDate>('dataFinal').value,
        }).then(() => {
            Utilities.showSuccessMessage();
            this.fecharModalPause();
            grid.datasource.get();
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
        });
    }

    public editarTarefasRecorrentes() {
        const grid = Metadata.getInstance<TekGrid>('tek-grid-tarefas-recorrentes');
        LoadingService.show();

        Http.post('/tarefasRecorrentes', {
            TIPO: 'EDITAR',
            NRTAREFARECORRENTE: this.linhaClicada.NRTAREFARECORRENTE,
            HORARIO: Metadata.getInstance<Time>('selectHoraInicio1').value,
            DURACAO: Metadata.getInstance<TextInput>('selectTempoMedio1').value,
            DIASSEMANA: Metadata.getInstance<SelectMultiple>('selectDiaSemana').value,
            CDOPERTAREFA: Metadata.getInstance<Select>('selectFuncionario').value,
            CDOPERVISTORIA: Metadata.getInstance<Select>('selectEncarregado').value,
        }).then(() => {
            Utilities.showSuccessMessage();
            this.fecharModalEdicao();
            grid.datasource.get();
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
        });
    }

    public cancelarRecorrencia() {
        const component = Metadata.getInstance<TekGrid>('tek-grid-tarefas-recorrentes');
        LoadingService.show();

        Http.post('/inativarTarefasRecorrentes', {
            NRS: component.selectedRows.map((element: any) => element.NRTAREFARECORRENTE),
            DATAINICIO: Metadata.getInstance<ZdDate>('dataInicio').value,
        }).then(() => {
            component.datasource.get();
            Utilities.showSuccessMessage();
            this.fecharModalCancelamento();
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            component.selectedRows = [];
            LoadingService.hide();
            DialogService.hide();
        });
    }

    public deletarRegistroRelatorio({ component }: any) {
        event?.preventDefault();
        LoadingService.show();

        Http.post('/delRegistroRelatorio', {
            NRS: component.selectedRows.map((element: any) => element.NRERROTAREFAREC),
        }).then(() => {
            component.datasource.get();
            Utilities.showSuccessMessage();
            this.fecharModalCancelamento();
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            component.selectedRows = [];
            LoadingService.hide();
            DialogService.hide();
        });
    }

    public iniciarTarefasRecorrentes() {
        const form = Metadata.getInstance<Form>('formPlayTarefa');
        const grid = Metadata.getInstance<TekGrid>('tek-grid-tarefas-recorrentes');
        if (form.validate()) {
            LoadingService.show();

            Http.post('/recriarTarefasRecorrentes', {
                NRTAREFARECORRENTE: this.linhaClicada.NRTAREFARECORRENTE,
                DATAINICIAL: Metadata.getInstance<ZdDate>('dataInicio').value,
            }).then(() => {
                Utilities.showSuccessMessage();
                this.fecharModalPlay();
                grid.datasource.get();
            }).catch((error: any) => {
                Utilities.showErrorMessage(error);
            }).finally(() => {
                LoadingService.hide();
                DialogService.hide();
            });
        }
    }

    /* ========== Controle dos modais e ROWCLICK do grid ========== */
    public rowClickGrid({ row }: any) {
        this.linhaClicada = row;
        if (this.botaoConflito != true) {
            this.rowClickFunction(row);
        }
    }

    public testeBotao({ row }: any) {
        this.linhaClicada = row;
        this.botaoConflito = true;
        this.gridEditavel = true;
        if (this.botaoConflito == true) {
            this.exibirRelatorio();
        }
    }

    public rowClickFunction(row: any) {
        this.clicks += 1;
        setTimeout(() => {
            if (this.clicks === 1) {
                this.modalPlayPause(row);
            } else if (this.clicks === 2 && row.NMIDSITUACAO !== 'Cancelada') {
                this.exibirModalEdicao();
            }
            this.clicks = 0;
            this.botaoConflito = false;
        }, 1000);
    }

    public pausarRecorrencia() {
        const form = Metadata.getInstance<Form>('formPlayPause');
        if (form.validate()) {
            if (!form.value.DataFinal) {
                this.pausarTarefaRecorrente();
            } else {
                this.pausarTarefaRecorrente();
            }
        }
    }

    // ========== Funções auxiliares ==========
    public async inicializarRecorrencia() {
        this.controlePlayPause = false;
    }

    public inativarTarefas({ event }: any) {
        event?.preventDefault();
        this.exibirModalCancelamento();
    }

    public mudaCor({ row }: any) {
        if (row.NMIDSITUACAO === 'Em Andamento') {
            return { 'color': '#85AB2C' };
        } else if (row.NMIDSITUACAO === 'Pausada') {
            return { 'color': '#5F96D1' };
        } else if (row.NMIDSITUACAO === 'Cancelada') {
            return { 'color': '#999999' };
        }
    }

    public visibilidadeConflitos({ row }: any) {
        if (row.IDERRO === 'N') {
            return false;
        } else {
            return true;
        }
    }

    public setFilter({ component }: any) {
        let nr = "";

        if (this.botaoConflito === true) {
            nr = this.linhaClicada['NRTAREFARECORRENTE']
        } else {
            nr = 'S'
        }
        component.datasource.setFilter({
            NRTAREFARECORRENTE: nr,
        });
    }

    // FUNÇÕES PARA CONTROLE DE CONFLITOS 

    // Recebe um intervalo de data/hora para ser comaprado com o grid afim de validar se há valores iguais.
    // dig == data inicial grid -- dfg == data final grid
    // din == data inicial nova -- dfn == data final nova
    public validaHorario(din: any, dfn: any, funcionario: any, encarregado: any, index: any, HORAINICIO: any) {
        const grid = Metadata.getInstance<TekGrid>('tek-grid-tarefas').datasource.data;
        grid.forEach(element => {
            const dig = Utilities.creatDate(element.DTHORAAGEND);
            const dfg = Utilities.creatDate(element.DTHRFINALAGEND);
            if (funcionario === element.CDOPERADOR) {
                if ((din.valueOf() >= dig.valueOf() && din.valueOf() <= dfg.valueOf()
                    || dfn.valueOf() >= dig.valueOf() && dfn.valueOf() <= dfg.valueOf()) ||
                    dig.valueOf() >= din.valueOf() && dig.valueOf() <= dfn.valueOf()
                    || dig.valueOf() >= din.valueOf() && dig.valueOf() <= dfn.valueOf()) {
                    this.conflitoRel = true;
                    const teste = this.conflitoDatas.findIndex((elemento: any) => elemento.INDEX == index);
                    if (teste < 0) {
                        this.conflitoDatas.push({
                            INDEX: index,
                            DHINICIALNOVA: din.toLocaleDateString('pt-br') + " " + ("00" + din.getHours()).slice(-2) + ':' + ("00" + din.getMinutes()).slice(-2),
                            DHFINALNOVA: dfn.toLocaleDateString('pt-br') + " " + ("00" + dfn.getHours()).slice(-2) + ':' + ("00" + dfn.getMinutes()).slice(-2),
                            INDEXPAI: null,
                            NMOPERADOR: element.NMOPERADOR,
                            CDOPERADOR: element.CDOPERADOR,
                            ENCARREGADO: encarregado,
                            HORAINICIO: HORAINICIO,
                            acoesSelect: 'Não',
                        });
                    }
                    this.conflitoDatas.push({
                        DHINICIALGRID: dig.toLocaleDateString('pt-br') + " " + ("00" + dig.getHours()).slice(-2) + ':' + ("00" + dig.getMinutes()).slice(-2),
                        DHFINALGRID: dfg.toLocaleDateString('pt-br') + " " + ("00" + dfg.getHours()).slice(-2) + ':' + ("00" + dfg.getMinutes()).slice(-2),
                        INDEX: `${index}${this.conflitoDatas.length}`,
                        INDEXPAI: index,
                        NRCHECKLISTAGEND: element.NRCHECKLISTAGEND,
                        NMCHECKLISTAGEND: element.NMCHECKLISTAGEND,
                    });

                }
            }
        });
    }

    public validaParametrizacao() {
        Http.get('getParametroConflito').then((response) => {
            this.parametrizacao = response.data[0]['IDVALIDACRIATAREFA'];
        });
    }

    // Pega as informações do form como data inicial, duração e funcionário. Formata para ser compatível com a data do Grid vinda do backEnd.
    public async formatarDataHora(editedRow: any, revalidar: boolean) {
        if (this.validaInsercao()) {
            let index = 1;
            if (revalidar == true) {
                // const grid = Metadata.getInstance<TekGrid>('tek-grid-nova-tarefa');
                const HORAINICIO = 0;
                editedRow.forEach((iteracoes: any) => {
                    let din = Utilities.creatDate(iteracoes.DHINICIALNOVA);
                    let dfn = Utilities.creatDate(iteracoes.DHFINALNOVA);
                    let CDOPERADOR = (iteracoes.NMOPERADOR.length == 12) ? iteracoes.NMOPERADOR : iteracoes.CDOPERADOR;
                    let duracao = ((dfn.valueOf() - din.valueOf()) / 1000 / 60);
                    const [hora, minuto] = (iteracoes.NRERROTAREFAREC > 0 && iteracoes.novoHorario) ? iteracoes.novoHorario.split(':') : iteracoes.HORAINICIO.split(':');
                    din.setHours(hora);
                    din.setMinutes(minuto);
                    dfn = new Date(din.valueOf());
                    dfn.setMinutes(dfn.getMinutes() + duracao);
                    this.validaHorario(din, dfn, CDOPERADOR, iteracoes.encarregado, iteracoes.INDEX, HORAINICIO);
                    if (iteracoes.NRERROTAREFAREC > 0) {
                        this.copy = JSON.parse(JSON.stringify(iteracoes));
                        this.copy['DURACAO'] = ("00" + (dfn.valueOf() - din.valueOf()) / 1000 / 60).slice(-2);
                        this.copy['DATAFINAL'] = dfn.toLocaleDateString('pt-br') + " " + ("00" + dfn.getHours()).slice(-2) + ':' + ("00" + dfn.getMinutes()).slice(-2);
                        this.copy["DATAINICIAL"] = din.toLocaleDateString('pt-br') + " " + ("00" + din.getHours()).slice(-2) + ':' + ("00" + din.getMinutes()).slice(-2);
                        this.copy["NRERROTAREFAREC"] = iteracoes.NRERROTAREFAREC;
                        this.copy["FUNCIONARIO"] = iteracoes.CDOPERADOR;
                        this.conflitoRelatorio.push(this.copy);
                    } else {
                        this.fecharModalConflitoDatas();
                        this.montaGrid();
                    }

                });
            } else {
                const dataInicial = Metadata.getInstance<DateRange>('selectDataDe').value;
                const dataFormatada = this.defineDataFinal(dataInicial);
                const diasSemana = Metadata.getInstance<SelectMultiple>('selectDiaSemana').value;
                this.conflitoDatas = [];
                this.bancoConflito = [];
                this.conflitoRelatorio = [];
                this.executorHora().forEach((element: any) => {
                    let dataInicio = new Date(dataFormatada[0]!.valueOf());

                    for (dataInicio; dataInicio <= dataFormatada[1]!; dataInicio.setDate(dataInicio.getDate() + 1)) {
                        if (diasSemana.includes(String(dataInicio.getDay()))) {
                            const din = new Date(dataInicio.valueOf());
                            const [hora, minuto] = element.HORAINICIO.split(':');
                            let HORAINICIO = element.HORAINICIO;
                            din.setHours(hora);
                            din.setMinutes(minuto);
                            const dfn = new Date(din.valueOf());
                            dfn.setMinutes(dfn.getMinutes() + (Math.trunc(element.DURACAO / 100) * 60) + (element.DURACAO % 100));
                            this.copy = JSON.parse(JSON.stringify(element));
                            this.copy['INDEX'] = index;
                            this.copy['DURACAO'] = ("00" + (dfn.valueOf() - din.valueOf()) / 1000 / 60).slice(-2);
                            this.copy['DATAFINAL'] = dfn.toLocaleDateString('pt-br') + " " + ("00" + dfn.getHours()).slice(-2) + ':' + ("00" + dfn.getMinutes()).slice(-2);
                            this.copy["DATAINICIAL"] = din.toLocaleDateString('pt-br') + " " + ("00" + din.getHours()).slice(-2) + ':' + ("00" + din.getMinutes()).slice(-2);
                            this.copy['NRSEQCONTRATO'] = element.NRSEQCONTRATO;
                            this.bancoConflito.push(this.copy);
                            (this.parametrizacao == "N") ? this.validaHorario(din, dfn, element.FUNCIONARIO, element.ENCARREGADO, index, HORAINICIO) : "";
                            index++;
                        }
                    }
                });
            }

            if (this.conflitoDatas.length > 0) {
                this.exibirModalConflitoDatas();
            } else if (this.conflitoRelatorio <= 0) {
                this.fecharModalTarefas();
                this.inserirTarefa();

                //this.title = Metadata.getInstance<TextInput>('nomeTarefa').value;
            } else {
                this.inserirTarefa();
                this.conflitoRelatorio = [];
            }

            revalidar = false;
        }
    }

    public confirmaInsercao() {
        if (this.conflitoDatas.length > 0) {
            Utilities.alertMessage('Existem conflitos pendentes!', 'error');
        } else {
            this.fecharModalConflitoDatas();
            this.fecharModalTarefas();
            this.inserirTarefa();
        }
    }

    public defineDataFinal(dataInicio: any) {
        let ultimoDia = new Date();
        let diaCorte = new Date();
        let dataInicial = new Date(dataInicio);
        let dataFinal;
        let mesSeguinte;
        ultimoDia = new Date(ultimoDia.getFullYear(), ultimoDia.getMonth() + 1, 0);
        mesSeguinte = ultimoDia.valueOf();
        mesSeguinte = new Date(mesSeguinte);
        diaCorte = new Date(diaCorte.getFullYear(), diaCorte.getMonth(), 25)
        if (dataInicial < ultimoDia) {
            dataFinal = (dataInicial > diaCorte) ? ultimoDia.setMonth(ultimoDia.getMonth() + 1) : ultimoDia;
        } else if (dataInicial > diaCorte && dataInicial.valueOf() < ultimoDia.setMonth(ultimoDia.getMonth() + 1)) {
            dataFinal = new Date(mesSeguinte.getFullYear(), mesSeguinte.getMonth() + 2, 0)
        }
        return [dataInicial, dataFinal];
    }

    public montaGrid() {
        const grid = Metadata.getInstance<TekGrid>('tek-grid-nova-tarefa');
        const dadosPai = this.conflitoDatas.filter((dados: any) => (dados.INDEXPAI == null))
        dadosPai.forEach((dados: any) => {
            grid.datasource.data.push({
                DHINICIALNOVA: dados.DHINICIALNOVA,
                DHFINALNOVA: dados.DHFINALNOVA,
                NMOPERADOR: dados.NMOPERADOR,
                INDEX: dados.INDEX,
                INDEXPAI: dados.INDEXPAI,
                NRCHECKLISTAGEND: dados.NRCHECKLISTAGEND,
                CDOPERADOR: dados.CDOPERADOR,
                HORAINICIO: dados.HORAINICIO,
                acoesSelect: dados.acoesSelect,
            });
        });
    }

    public montaGridConflito({ row }: any) {
        const grid = Metadata.getInstance<TekGrid>('tek-grid-conflito-datas');
        grid.datasource.data = [];
        const dadosFilho = this.conflitoDatas.filter((dados: any) => (dados.INDEXPAI == row.INDEX))
        dadosFilho.forEach((dados: any) => {
            grid.datasource.data.push({
                DHINICIALGRID: dados.DHINICIALGRID,
                DHFINALGRID: dados.DHFINALGRID,
                NRCHECKLISTAGEND: dados.NRCHECKLISTAGEND,
                NMCHECKLISTAGEND: dados.NMCHECKLISTAGEND,
                INDEX: dados.INDEX,
                INDEXPAI: dados.INDEXPAI
            });
        });
        this.rowClickFiltroGrid();
    }

    public rowClickFiltroGrid() {
        this.visibilidadeGridItens = true;
        this.visibilidadeForm = !this.visibilidadeGridItens;
    }

    public verificarConflitos({ component }: IEventParam<TekGrid>) {
        if (Utilities.validateGrid(component)) {
            this.atualizaBancoConflitos(component.getEditedRows());
            const alteracoes: any = component.getEditedRows().filter((elemento: any) => elemento.acoesSelect != 1);
            const revalidar = true;
            this.conflitoDatas = [];
            this.formatarDataHora(alteracoes, revalidar);
        }
    }

    public atualizaBancoConflitos(dadosEditados: any) {
        dadosEditados.forEach((element: any) => {
            if (dadosEditados.find((relatorio: any) => relatorio.NRERROTAREFAREC)) {
                const dataInicio = Utilities.creatDate(element['DHINICIALNOVA']);
                const dataFinal = Utilities.creatDate(element['DHFINALNOVA']);
                const din = new Date(dataInicio.valueOf());
                const [hora, minuto] = element.HORAINICIO.split(':');
                let dfn = new Date(dataFinal.valueOf());
                const DURACAO = dfn.valueOf() - din.valueOf();
                din.setHours(hora);
                din.setMinutes(minuto);
                dfn = new Date(din.valueOf() + DURACAO);
                this.conflitoRelatorio["FUNCIONARIO"] = (element.NMOPERADOR.length == 12) ? element.NMOPERADOR : element.CDOPERADOR;
                this.bancoConflito["DATAINICIAL"] = din.toLocaleDateString('pt-br') + " " + ("00" + din.getHours()).slice(-2) + ':' + ("00" + din.getMinutes()).slice(-2);
                this.bancoConflito['DATAFINAL'] = din.toLocaleDateString('pt-br') + " " + ("00" + dfn.getHours()).slice(-2) + ':' + ("00" + dfn.getMinutes()).slice(-2);

            } else {
                const dataInicio = Utilities.creatDate(element['DHINICIALNOVA']);
                const dataFinal = Utilities.creatDate(element['DHFINALNOVA']);
                const din = new Date(dataInicio.valueOf());
                let dfn = new Date(dataFinal.valueOf());
                const DURACAO = dfn.valueOf() - din.valueOf();
                const [hora, minuto] = element.HORAINICIO.split(':');
                din.setHours(hora);
                din.setMinutes(minuto);
                dfn = new Date(din.valueOf() + DURACAO);
                const pos = this.bancoConflito.findIndex((dados: any) => dados.INDEX == element.INDEX);
                this.bancoConflito[pos]["FUNCIONARIO"] = (element.NMOPERADOR.length == 12) ? element.NMOPERADOR : element.CDOPERADOR;
                this.bancoConflito[pos]["DATAINICIAL"] = din.toLocaleDateString('pt-br') + " " + ("00" + din.getHours()).slice(-2) + ':' + ("00" + din.getMinutes()).slice(-2);
                this.bancoConflito[pos]["IGNORAR"] = element.acoesSelect;
                this.bancoConflito[pos]['DATAFINAL'] = din.toLocaleDateString('pt-br') + " " + ("00" + dfn.getHours()).slice(-2) + ':' + ("00" + dfn.getMinutes()).slice(-2);
            }
        });
    }
}
